import java.util.ArrayList;

/**
 * The Snake class represents the player-controlled snake. 
 *
 * The Game class instantiates this class exactly once, when a new level is
 * loaded.
 */
public class Snake 
{
	// Private variables to hold the GraphicObject associated with the snake's head
	// and an ArrayList of GraphicObject associated with the snake's body
	private GraphicObject head;
	private ArrayList<GraphicObject> body;

	/**
	 * Initializes a new Snake object at the specified (x,y) position.
	 * 
	 * TODO: Implement this.
	 * 
	 * @param x		the initial x position of the snake
	 * @param y		the initial y position of the snake
	 */
	public Snake(float x, float y)
	{
		// Initialize new ArrayList to hold body segments
		// Initialize the head
		// Set the speed of the head
		// Set the direction of the head
		// Add the head to the list of body segments
		// Add four body segments (grow the snake four times)
	}

	/**
	 * Returns the GraphicObject associated with the head of this snake.
	 *  
	 * TODO: Implement this.
	 * 
	 * @returns the GraphicObject associated with the head of this snake
	 */
	public GraphicObject getGraphicObject() 
	{
		return null;
	}

	/**
	 * Grows the snake by one body segment.
	 * 
	 * TODO: Implement this.
	 */
	public void grow()
	{
		// Create a new GraphicObject with type "BODY"
		// Set the new body segment's size to 10
		// Find the last body segment in the list of body segments
		// Set the leader of the new body segment to be the last body segment
		// Add the new body segment to the end of the list of body segments
	}

	/**
	 * Reads keyboard input and changes the snake's direction as necessary.
	 * 
	 * TODO: Implement this.
	 * 
	 * @param controlType - 1: classic, 2: analog, 3: slither
	 */
	public void updateMoveDirection(int controlType)
	{
		// if controlType is one
			// implementation for controlType one
		// if controlType is two
			// implementation for controlType two
		// if controlType is three
			// implementation for controlType three
	}

	/**
	 * Kills the snake if the head is colliding with any of the body segments.
	 * 
	 * TODO: Implement this.
	 */
	public void dieIfCollidingWithOwnBody()
	{
		// For each game object in the body...
			// if the head is colliding with this segment...
				// tell the snake to die.
	}

	/**
	 * Kills the snake.
	 * 
	 * TODO: Implement this.
	 */
	public void die()
	{
		// Set the head's type to "DEAD"
		// For each GraphicObject in the snake's body, set its type to "DEAD"
	}

	/**
	 * Returns true if the snake is dead.
	 * 
	 * TODO: Implement this.
	 * 
	 * @return true if the snake is dead, false otherwise
	 */
	public boolean isDead() {
		return false;
	}
}
